(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = global || self, factory(global.debe = global.debe || {}));
}(this, function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function chunk(list, chunkSize) {
        if (chunkSize === void 0) { chunkSize = 10000; }
        return new Array(Math.ceil(list.length / chunkSize))
            .fill(0)
            .map(function (_, i) {
            return list.slice(i * chunkSize, i * chunkSize + chunkSize);
        });
    }
    function chunkWork(items, max, work) {
        if (max === void 0) { max = [250000, 10000]; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2, chunkSequencial(items, max[0], function (items) {
                        return chunkParallel(items, max[1], work);
                    })];
            });
        });
    }
    function chunkSequencial(items, max, work) {
        if (max === void 0) { max = 1000; }
        return __awaiter(this, void 0, void 0, function () {
            var results;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        results = [];
                        return [4, chunk(items, max).reduce(function (state, items) {
                                return state.then(function () {
                                    return work(items).then(function (result) { return (results = results.concat(result)); });
                                });
                            }, Promise.resolve())];
                    case 1:
                        _a.sent();
                        return [2, results];
                }
            });
        });
    }
    function chunkParallel(items, max, work) {
        if (max === void 0) { max = 1000; }
        return __awaiter(this, void 0, void 0, function () {
            var results, resultSet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        results = [];
                        return [4, Promise.all(chunk(items, max).map(function (items) { return work(items); }))];
                    case 1:
                        resultSet = _a.sent();
                        resultSet.forEach(function (result) { return (results = results.concat(result)); });
                        return [2, results];
                }
            });
        });
    }

    function ensureQuery(value) {
        if (!value) {
            value = {};
        }
        if (value.id) {
            if (Array.isArray(value.id)) {
                value.where = ["id IN (?)", value.id];
            }
            else {
                value.where = ["id = ?", value.id];
            }
        }
        if (Array.isArray(value.limit) && value.limit.length === 2) {
            value.offset = value.limit[1];
            value.limit = value.limit[0];
        }
        else if (Array.isArray(value.limit) && value.limit.length === 1) {
            value.limit = value.limit[0];
        }
        value.select = value.select ? ensureArray(value.select) : undefined;
        value.orderBy = value.orderBy ? ensureArray(value.orderBy) : undefined;
        value.id = value.id ? ensureArray(value.id) : undefined;
        return value;
    }
    function ensureArray(obj) {
        if (obj && !Array.isArray(obj)) {
            return [obj];
        }
        else if (!obj) {
            return [];
        }
        else {
            return obj;
        }
    }

    var types = {
        LISTEN: 'listen',
        INSERT: 'insert',
        GET: 'get',
        ALL: 'all',
        COUNT: 'count',
        CLOSE: 'close',
        REMOVE: 'remove',
        INITIALIZE: 'initialize',
        COLLECTION: 'collection',
        COLLECTIONS: 'collections'
    };

    var Debe = (function () {
        function Debe(dispatcher) {
            this.isInitialized = false;
            this.dispatcher = dispatcher;
            dispatcher.db = this;
        }
        Debe.prototype.close = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4, this.dispatcher.close()];
                        case 1:
                            _a.sent();
                            return [2];
                    }
                });
            });
        };
        Debe.prototype.initialize = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.initializing) {
                                this.initializing = this.dispatcher.initialize();
                            }
                            return [4, this.initializing];
                        case 1:
                            _a.sent();
                            this.isInitialized = true;
                            return [2, this];
                    }
                });
            });
        };
        Debe.prototype.use = function (collection) {
            var proxy = this;
            return new Proxy({}, {
                get: function (t, methodName) {
                    return function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        return proxy[methodName].apply(proxy, __spread([collection], args));
                    };
                }
            });
        };
        Debe.prototype.listen = function (collection, callback) {
            return this.dispatcher.listen('insert', callback, { collection: collection });
        };
        Debe.prototype.insert = function (collection, value, optionsInput) {
            if (optionsInput === void 0) { optionsInput = {}; }
            var options = __assign({ refetchResult: false, update: true }, optionsInput);
            if (Array.isArray(value)) {
                return this.dispatcher.run('insert', collection, value, options);
            }
            return this.dispatcher
                .run('insert', collection, [value], options)
                .then(function (x) { return (Array.isArray(x) ? x[0] : x); });
        };
        Debe.prototype.remove = function (collection, value) {
            if (Array.isArray(value)) {
                return this.dispatcher.run('remove', collection, value);
            }
            return this.dispatcher
                .run('remove', collection, [value])
                .then(function (x) { return x && x[0]; });
        };
        Debe.prototype.all = function (collection, value, callback) {
            if (value && typeof value === 'function') {
                callback = value;
                value = undefined;
            }
            if (value && typeof value === 'string') {
                value = { id: value };
            }
            else if (value && Array.isArray(value)) {
                value = { id: value };
            }
            else if (value && typeof value === 'object' && Array.isArray(value.id)) {
                value = { id: value.id };
            }
            var query = ensureQuery(value);
            if (callback) {
                return this.dispatcher.listen('all', callback, {
                    collection: collection,
                    query: query
                });
            }
            return this.dispatcher.run('all', collection, query);
        };
        Debe.prototype.count = function (collection, value, callback) {
            if (value && typeof value === 'function') {
                callback = value;
                value = undefined;
            }
            if (value && typeof value === 'string') {
                value = { id: value };
            }
            else if (value && Array.isArray(value)) {
                value = { id: value };
            }
            else if (value && typeof value === 'object' && Array.isArray(value.id)) {
                value = { id: value.id };
            }
            var query = ensureQuery(value);
            if (callback) {
                return this.dispatcher.listen('count', callback, {
                    collection: collection,
                    query: query
                });
            }
            return this.dispatcher.run('count', collection, query);
        };
        Debe.prototype.get = function (collection, value, callback) {
            if (value && typeof value === 'function') {
                callback = value;
                value = undefined;
            }
            if (value &&
                typeof value === 'object' &&
                value.id &&
                !Array.isArray(value.id)) {
                value = value.id;
            }
            if (value && typeof value === 'string') {
                if (callback) {
                    return this.dispatcher.listen('get', callback, {
                        collection: collection,
                        query: value
                    });
                }
                return this.dispatcher.run('get', collection, value);
            }
            if (value && Array.isArray(value)) {
                value = { id: value };
            }
            else if (value && typeof value === 'object' && Array.isArray(value.id)) {
                value = { id: value.id };
            }
            var query = ensureQuery(value);
            if (callback !== undefined) {
                var cb_1 = callback;
                return this.dispatcher.listen('all', function (error, value) { return cb_1(error, error ? undefined : value[0]); }, {
                    collection: collection,
                    query: query
                });
            }
            return this.dispatcher
                .run('all', collection, query)
                .then(function (x) { return x && x[0]; });
        };
        return Debe;
    }());

    var DebeDispatcher = (function () {
        function DebeDispatcher() {
        }
        return DebeDispatcher;
    }());

    var create = require('asyngular-client').create;
    var allowedMethods = [
        types.INSERT,
        types.REMOVE,
        types.GET,
        types.ALL,
        types.COUNT
    ];
    var SocketDebe = (function (_super) {
        __extends(SocketDebe, _super);
        function SocketDebe(_a) {
            var _b = __read(_a, 2), hostname = _b[0], _c = _b[1], port = _c === void 0 ? 8000 : _c;
            return _super.call(this, new SocketAdapter(hostname, port)) || this;
        }
        return SocketDebe;
    }(Debe));
    var SocketAdapter = (function (_super) {
        __extends(SocketAdapter, _super);
        function SocketAdapter(hostname, port, secure) {
            if (port === void 0) { port = 8000; }
            var _this = _super.call(this) || this;
            _this.socket = create({
                hostname: hostname,
                secure: secure === true || secure === false ? secure : port === 443,
                port: port
            });
            return _this;
        }
        SocketAdapter.prototype.initialize = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    this.start();
                    return [2];
                });
            });
        };
        SocketAdapter.prototype.close = function () {
            return __awaiter(this, void 0, void 0, function () {
                var promise;
                return __generator(this, function (_a) {
                    promise = Promise.race([
                        this.socket.listener('disconnect')['once'](),
                        this.socket.listener('connectAbort')['once']()
                    ]);
                    this.socket.disconnect();
                    return [2, promise];
                });
            });
        };
        SocketAdapter.prototype.start = function () {
            var e_1, _a;
            return __awaiter(this, void 0, void 0, function () {
                var _b, _c, event_1, e_1_1;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 5, 6, 11]);
                            _b = __asyncValues(this.socket.listener('connect'));
                            _d.label = 1;
                        case 1: return [4, _b.next()];
                        case 2:
                            if (!(_c = _d.sent(), !_c.done)) return [3, 4];
                            event_1 = _c.value;
                            _d.label = 3;
                        case 3: return [3, 1];
                        case 4: return [3, 11];
                        case 5:
                            e_1_1 = _d.sent();
                            e_1 = { error: e_1_1 };
                            return [3, 11];
                        case 6:
                            _d.trys.push([6, , 9, 10]);
                            if (!(_c && !_c.done && (_a = _b.return))) return [3, 8];
                            return [4, _a.call(_b)];
                        case 7:
                            _d.sent();
                            _d.label = 8;
                        case 8: return [3, 10];
                        case 9:
                            if (e_1) throw e_1.error;
                            return [7];
                        case 10: return [7];
                        case 11: return [2];
                    }
                });
            });
        };
        SocketAdapter.prototype.run = function (action, collection, payload, options) {
            var _this = this;
            if (action === 'insert') {
                return chunkWork(payload, [250000, 10000], function (items) { return _this.socket.invoke('insert', [collection, items, options]); });
            }
            return this.socket.invoke(action, [collection, payload, options]);
        };
        SocketAdapter.prototype.listen = function (action, callback, options) {
            var _this = this;
            var channelId = "" + Math.random()
                .toString(36)
                .substr(2, 9);
            var listen = function () { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, data, e_2_1;
                var e_2, _c;
                return __generator(this, function (_d) {
                    switch (_d.label) {
                        case 0:
                            _d.trys.push([0, 5, 6, 11]);
                            _a = __asyncValues(this.socket.receiver(channelId));
                            _d.label = 1;
                        case 1: return [4, _a.next()];
                        case 2:
                            if (!(_b = _d.sent(), !_b.done)) return [3, 4];
                            data = _b.value;
                            callback(data[0], data[1]);
                            _d.label = 3;
                        case 3: return [3, 1];
                        case 4: return [3, 11];
                        case 5:
                            e_2_1 = _d.sent();
                            e_2 = { error: e_2_1 };
                            return [3, 11];
                        case 6:
                            _d.trys.push([6, , 9, 10]);
                            if (!(_b && !_b.done && (_c = _a.return))) return [3, 8];
                            return [4, _c.call(_a)];
                        case 7:
                            _d.sent();
                            _d.label = 8;
                        case 8: return [3, 10];
                        case 9:
                            if (e_2) throw e_2.error;
                            return [7];
                        case 10: return [7];
                        case 11: return [2];
                    }
                });
            }); };
            listen();
            this.socket.transmit('subscribe', [channelId, action, options]);
            var close = function () {
                setTimeout(function () { return _this.socket.closeReceiver(channelId); });
            };
            return close;
        };
        return SocketAdapter;
    }(DebeDispatcher));

    exports.SocketAdapter = SocketAdapter;
    exports.SocketDebe = SocketDebe;
    exports.allowedMethods = allowedMethods;
    exports.create = create;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
